type tstop
  field w:twin
  field b:tbut

  method new()
    w=createwin("Stop",0,0,200,200,15-window_status-window_menu+window_hidden,win.g)
    w.center
    w.reset
    b=new tbut
    b.add "&Stop",1,0,0,w.cw,w.ch,w.g,,button_cancel
    w.kid=b.g[b.g.length-1]
  endmethod

  method load(f:tstream)
    w.load f
    w.reset
  endmethod
  method save(f:tstream)
    w.save f
  endmethod

  method upd%()
    select w.upd()
    case event_windowclose  return true
    endselect

    select b.upd()
    case 1 return true
    endselect
  endmethod
endtype

type _tfiles
  field nxt:_tfiles
  field prv:_tfiles
  field down:_tfiles
  field name$
  field typ%
  field size%
endtype
type tfiles extends talloc
  field d:_tfiles[]
  field drive1:_tfiles
  field indrive:_tfiles
  field indir:_tfiles
  field infile:_tfiles
  field dirs%,files%,size%[]
  field laststat$
  const dirid%=$100

  method save(f:tstream)
'    writepint f,dirs
'    writepint f,files
    writepint f,d.length
    local p1%=f.pos()
    local c1%
    writeint f,0
    local i1:_tfiles=drive1
    while i1
      writebyte f,i1.name[0]
      local p2%=f.pos()
      local c2%
      writeint f,0
      local i2:_tfiles=i1.down
      while i2
        writestr f,i2.name
        local p3%=f.pos()
        local c3%
        writeint f,0
        local i3:_tfiles=i2.down
        while i3
          writepint f,i3.name.length|(i3.typ*dirid)
          writestring f,i3.name
          if not i3.typ then writepint f,i3.size
          c3:+1
          i3=i3.nxt
        wend
        f.seek p3
        writeint f,c3
        f.seek f.size()
        c2:+1
        i2=i2.nxt
      wend
      f.seek p2
      writeint f,c2
      f.seek f.size()
      c1:+1
      i1=i1.nxt
    wend
    f.seek p1
    writeint f,c1
    f.seek f.size()
  endmethod
  method load(f:tstream)
'    dirs=readpint(f)
'    files=readpint(f)
    dirs=0
    files=0
    drive1=null
    pos=0
    d=d[..readpint(f)]
    local o1:_tfiles
    local c1%=readint(f)
    while c1
      d[pos]=new _tfiles
      indrive=d[pos]
      pos:+1
      if o1 then
        indrive.prv=o1
        o1.nxt=indrive
      endif
      o1=indrive
      indrive.name=chr(readbyte(f))
      local o2:_tfiles
      local c2%=readint(f)
      while c2
        d[pos]=new _tfiles
        indir=d[pos]
        pos:+1
        if o2 then
          indir.prv=o2
          o2.nxt=indir
        else
          indrive.down=indir
        endif
        o2=indir
        indir.name=readstr(f)
        local o3:_tfiles
        local c3%=readint(f)
        while c3
          d[pos]=new _tfiles
          infile=d[pos]
          pos:+1
          if o3 then
            infile.prv=o3
            o3.nxt=infile
          else
            indir.down=infile
          endif
          o3=infile
          local l%=readpint(f)
          if (l&dirid) then
            infile.name=readstring(f,l&~dirid)
            infile.typ=1
            dirs:+1
          else
            infile.name=readstring(f,l)
            infile.size=readpint(f)
            files:+1
          endif
          c3:-1
        wend
        c2:-1
      wend
      c1:-1
    wend
    if d then drive1=d[0]
  endmethod
  method merge(f:tstream)
    readpint(f)
    local c1%=readint(f)
    while c1
      adddrive chr(readbyte(f))
      local c2%=readint(f)
      while c2
        adddir readstr(f)
        local c3%=readint(f)
        while c3
          local l%=readpint(f)
          if (l&dirid) then
            addfile readstring(f,l&~dirid),1,0
          else
            local n$=readstring(f,l)
            addfile n,0,readpint(f)
          endif
          c3:-1
        wend
        c2:-1
      wend
      c1:-1
    wend
'    drive1=d[0]
  endmethod
  method override(f:tstream)
    readpint(f)
    local c1%=readint(f)
    while c1
      local n$=chr(readbyte(f))
      deldrive n
      cleanup
      qadddrive n
      local c2%=readint(f)
      while c2
        qadddir readstr(f)
        local c3%=readint(f)
        while c3
          local l%=readpint(f)
          if (l&dirid) then
            qaddfile readstring(f,l&~dirid),1,0
          else
            local n$=readstring(f,l)
            qaddfile n,0,readpint(f)
          endif
          c3:-1
        wend
        c2:-1
      wend
      c1:-1
    wend
'    drive1=d[0]
  endmethod
rem
  method override2(f:tstream)
    ms=millisecs()
    readpint(f)
    local c1%=readint(f)
    while c1
      adddrive chr(readbyte(f))
      local c2%=readint(f)
      while c2
        local n$=readstr(f)
        deldir n
        qadddir n
        local c3%=readint(f)
        while c3
          local l%=readpint(f)
          if (l&dirid) then
            qaddfile readstring(f,l&~dirid),1,0
          else
            local n$=readstring(f,l)
            qaddfile n,0,readpint(f)
          endif
          c3:-1
        wend
        c2:-1
      wend
      c1:-1
    wend
'    drive1=d[0]
    ms=millisecs()-ms
  endmethod
endrem

  method status(ad$,win:tgadget)
    if ad then laststat=ad else ad=laststat
    count
    local t$=convertstr(strstatus,"%1",pointed(dirs+files))
    t=convertstr(t,"%2",filesize2str(size))
    t=convertstr(t,"%3",pointed(dirs))
    t=convertstr(t,"%4",pointed(files))
    setstatustext win,t+ad
'    setstatustext win,pointed(dirs+files)+" Objects("+filesize2str(size)+"), "..
'     +pointed(dirs)+" Folder, "..
'     +pointed(files)+" Files"..', Image:"+trimfile(lastimg)..
'     +ad
  endmethod

  method reset()
    drive1=null
    pos=0
    d=d[..pre]
    dirs=0
    files=0
    cleanup
  endmethod

  method drives$()
    local ret$
    local i:_tfiles=drive1
    while i
      ret:+i.name+":\~n"
      i=i.nxt
    wend
    return ret
  endmethod
  method count()
    dirs=0
    files=0
    size=size[..0]
    local i1:_tfiles=drive1
    while i1
      local i2:_tfiles=i1.down
      while i2
        local i3:_tfiles=i2.down
        while i3
          if i3.typ then
            dirs:+1
          else
            files:+1
            addfilesize size,i3.size
          endif
          i3=i3.nxt
        wend
        i2=i2.nxt
      wend
      i1=i1.nxt
    wend
  endmethod

  function swap(f1:_tfiles,f2:_tfiles)
    local x3:_tfiles=f1.down
    f1.down=f2.down
    f2.down=x3

    local x1$=f1.name
    f1.name=f2.name
    f2.name=x1

    local x2%=f1.typ
    f1.typ=f2.typ
    f2.typ=x2
    x2=f1.size
    f1.size=f2.size
    f2.size=x2
  endfunction
  method sort()
    local i1:_tfiles=drive1
    while i1' and i1.nxt
      local n$=i1.name
      local ils:_tfiles
      local ic:_tfiles=i1.nxt
      while ic
        if (n>ic.name) then
          n=ic.name
          ils=ic
        endif
        ic=ic.nxt
      wend
      if not ils then exit
      swap i1,ils
      i1=i1.nxt
    wend

    i1=drive1
    while i1
      local i2:_tfiles=i1.down
      while i2' and i2.nxt
        local n$=lower(i2.name)
        local ils:_tfiles
        local ic:_tfiles=i2.nxt
        while ic
          if (n>lower(ic.name)) then
            n=lower(ic.name)
            ils=ic
          endif
          ic=ic.nxt
        wend
        if not ils then exit
        swap i2,ils
        i2=i2.nxt
      wend
      i1=i1.nxt
    wend

    i1=drive1
    while i1
      local i2:_tfiles=i1.down
      while i2' and i2.nxt
        local i3:_tfiles=i2.down
        while i3' and i3.nxt
          local n$=lower(i3.name)
          local ils:_tfiles
          local ic:_tfiles=i3.nxt
          while ic
            if (n>lower(ic.name)) then
              n=lower(ic.name)
              ils=ic
            endif
            ic=ic.nxt
          wend
          if not ils then exit
          swap i3,ils
          i3=i3.nxt
        wend
        i2=i2.nxt
      wend
      i1=i1.nxt
    wend
  endmethod
rem
  method sort2()
    local i1:_tfiles=drive1
    while i1
      local n$=i1.name
      local ils:_tfiles
      local ic:_tfiles=i1.nxt
      while ic
        if (n>ic.name) then
          n=ic.name
          ils=ic
        endif
        ic=ic.nxt
      wend
      if ils then swap i1,ils

      local i2:_tfiles=i1.down
      while i2' and i2.nxt
        n=lower(i2.name)
        ils=null
        ic=i2.nxt
        while ic
          if (n>lower(ic.name)) then
            n=lower(ic.name)
            ils=ic
          endif
          ic=ic.nxt
        wend
        if ils then swap i2,ils

        local i3:_tfiles=i2.down
        while i3' and i3.nxt
          n=lower(i3.name)
          ils=null
          ic=i3.nxt
          while ic
            if (n>lower(ic.name)) then
              n=lower(ic.name)
              ils=ic
            endif
            ic=ic.nxt
          wend
          if not ils then exit
          swap i3,ils
          i3=i3.nxt
        wend
        i2=i2.nxt
      wend
      i1=i1.nxt
    wend
  endmethod
endrem

  method cleanup()
'local de$=pos+":"+d.length
    pos=0
    local i1:_tfiles=drive1
    while i1
      local i2:_tfiles=i1.down
      while i2
        local i3:_tfiles=i2.down
        while i3
          pos:+1
          i3=i3.nxt
        wend
        pos:+1
        i2=i2.nxt
      wend
      pos:+1
      i1=i1.nxt
    wend

    local d2:_tfiles[(pos&npre)+pre]
    pos=0
    local o1:_tfiles
    i1=drive1
    while i1
      d2[pos]=new _tfiles
      indrive=d2[pos]
      pos:+1
      if o1 then
        indrive.prv=o1
        o1.nxt=indrive
      endif
      o1=indrive
      indrive.name=i1.name
      local o2:_tfiles
      local i2:_tfiles=i1.down
      while i2
        d2[pos]=new _tfiles
        indir=d2[pos]
        pos:+1
        if o2 then
          indir.prv=o2
          o2.nxt=indir
        else
          indrive.down=indir
        endif
        o2=indir
        indir.name=i2.name
        local o3:_tfiles
        local i3:_tfiles=i2.down
        while i3
          d2[pos]=new _tfiles
          infile=d2[pos]
          pos:+1
          if o3 then
            infile.prv=o3
            o3.nxt=infile
          else
            indir.down=infile
          endif
          o3=infile
          infile.name=i3.name
          infile.typ=i3.typ
          infile.size=i3.size
          i3=i3.nxt
        wend
        i2=i2.nxt
      wend
      i1=i1.nxt
    wend
    d=d2
    if d then drive1=d[0] else drive1=null
'print de+" - "+pos+":"+d.length
  endmethod

  method finddrive:_tfiles(url$)
    local i:_tfiles=drive1
    while i
      if (i.name=url) then return i
      i=i.nxt
    wend
  endmethod
  method qadddrive(url$)
    local nl%=leng(pos+1)
    if (nl<>d.length) then d=d[..nl]
    d[pos]=new _tfiles
    indrive=d[pos]
    indrive.name=url
    if drive1 then
      indrive.nxt=drive1
      drive1.prv=indrive
    endif
    drive1=indrive
    pos:+1
  endmethod
  method adddrive(url$)
    indrive=finddrive(url)
    if not indrive then qadddrive url
  endmethod
'  method qdeldrive()
'    if not indrive then return
'    if (drive1=indrive) then drive1=indrive.nxt
'    if indrive.nxt then indrive.nxt.prv=indrive.prv
'    if indrive.prv then indrive.prv.nxt=indrive.nxt
'    indrive=null'drive1
'  endmethod
  method deldrive(url$)
    indrive=finddrive(url)
    if not indrive then return
    if (drive1=indrive) then drive1=indrive.nxt
    if indrive.nxt then indrive.nxt.prv=indrive.prv
    if indrive.prv then indrive.prv.nxt=indrive.nxt
    indrive=null'drive1
  endmethod

  method finddir:_tfiles(url$)
    if not indrive then return null
    local i:_tfiles=indrive.down
    while i
      if (lower(i.name)=url) then return i
      i=i.nxt
    wend
  endmethod
  method qadddir(url$)
    local nl%=leng(pos+1)
    if (nl<>d.length) then d=d[..nl]
    d[pos]=new _tfiles
    indir=d[pos]
    indir.name=url
    indir.nxt=indrive.down
    if indrive.down then indrive.down.prv=indir
    indrive.down=indir
    pos:+1
  endmethod
  method adddir(url$)
    indir=finddir(lower(url))
    if not indir then qadddir url
  endmethod
  method radddir(url$) 'recursive
    indir=finddir(lower(url))
    if indir then return
    local r:_tfiles=indir
    local l$
    local a%=countchar(url,asc"\")
    repeat
'print url
      adddir url
      if l then addfile l,1,0
      l=trimfile(delast(url))
      url=decpathr(url,1)
      a:-1
    until (a<0)
    indir=r
  endmethod
  method deldir(url$)
'    if not indir then return
    local i:_tfiles=indrive.down
    while i
      if (lower(left(i.name,url.length))=url) then
        if (indrive.down=i) then indrive.down=i.nxt
        if i.nxt then i.nxt.prv=i.prv
        if i.prv then i.prv.nxt=i.nxt
      endif
      i=i.nxt
    wend

    local l$=decpathr(url,1)
    i=indrive.down
    while i
      if (l=lower(i.name)) then
        indir=i
        delfile trimfile(delast(url))
        exit
      endif
      i=i.nxt
    wend
    indir=null'indrive.down
  endmethod

  method findfile:_tfiles(url$)
    if not indir then return null
    local i:_tfiles=indir.down
    while i
      if (lower(i.name)=url) then return i
      i=i.nxt
    wend
  endmethod
  method qaddfile(url$,tp%,sz%)
    local nl%=leng(pos+1)
    if (nl<>d.length) then d=d[..nl]
    d[pos]=new _tfiles
    infile=d[pos]
    infile.name=url
    infile.typ=tp
    infile.size=sz
    infile.nxt=indir.down
    if indir.down then indir.down.prv=infile
    indir.down=infile
    pos:+1
  endmethod
  method addfile(url$,tp%,sz%)
    infile=findfile(lower(url))
    if not infile then
      qaddfile url,tp,sz
    else
      infile.typ=tp
      infile.size=sz
    endif
  endmethod
  method delfile(url$)
    infile=findfile(url)'trimfile(url))
    if not infile then return
    if (indir.down=infile) then indir.down=infile.nxt
    if infile.nxt then infile.nxt.prv=infile.prv
    if infile.prv then infile.prv.nxt=infile.nxt
    if infile.typ then deldir indir.name+infile.name+"\"
    infile=null'indir.down
  endmethod

  method readfolder(url$,sub%)
    adddrive upper(url[..1])
    local t$=trimpathm(url)
    radddir t
    deldir lower(t)
'    qadddir decpathr(url,1)
    cleanup
    indrive=finddrive(upper(url[..1]))
    adddir decpathr(t,1)
    addfile trimfile(delast(t)),1,0
    qadddir t
    local dd:tdir=new tdir
    dd.reset trimpath(url),true
    while (dd.flag&1)
      if (dd.flag&4) then
        if not sub then exit
  pollevent
  if stop.upd() then exit
  if (currentevent.source=timer) then
    setstatustext win.g,dd.path+dd.dir[0]
  endif
        qadddir t+dd.dir[0]
      endif
      if (dd.flag&2) then
        qaddfile dd.this,1,0
      else
        qaddfile dd.this,0,filesize(dd.path+dd.dir[0]+dd.this)
      endif
      dd.upd
    wend
    dd.close
  endmethod

  method find%(url$,fil%,extr%,shsz%,bysz%,limit%,fsz%[] var)
    local u1$=trimdrive(url)
    if u1 then u1=upper(u1[..1])
    local u2$=trimpathm(url)
    local u3$=trimfile(url)
    local cal$=") found of "+pointed(dirs+files)
    local c%
    local i1:_tfiles=drive1
    while i1
      if not u1 or (i1.name=u1) then
        local i2:_tfiles=i1.down
        while i2
  pollevent
          if stop.upd() then return c
  if (currentevent.source=timer) then
    setstatustext win.g,pointed(c)+"("+filesize2str(fsz)+cal
  endif
          if not u2 or instrpath(lower(i2.name),u2) then
            if extr and u2 then
              text.add2 i1.name+":\"+i2.name+"~n",d2col.col
              c:+1
            endif
            local i3:_tfiles=i2.down
            while i3
              if not u3 or instrfile(lower(i3.name),u3) then
                if i3.typ then
                  text.add2 i1.name+":\"+i2.name+i3.name+"~n",dcol.col
                  c:+1
                elseif fil then
                  addfilesize fsz,i3.size
                  if shsz then
                    if bysz then
                      text.add2 pointed(i3.size)+strbyte+strbyte2+i1.name+":\"+i2.name+i3.name+"~n",fcol.col
                    else
                      local ssz%[]
                      addfilesize ssz,i3.size
                      text.add2 filesize2str(ssz)+strbyte2+i1.name+":\"+i2.name+i3.name+"~n",fcol.col
                    endif
                  else
                    text.add2 i1.name+":\"+i2.name+i3.name+"~n",fcol.col
                  endif
                  c:+1
                endif
if limit and (c>=limit) then
postevent createevent(event_gadgetaction,stop.b.g[0])
exit
endif
              endif
              i3=i3.nxt
            wend
          endif
          i2=i2.nxt
        wend
      endif
      i1=i1.nxt
    wend
    return c
  endmethod

rem
  function tostr$(i:_tfiles)
    local t$=i.typ
    if not i.typ then t:+"|"+i.size
    t:+":"+i.name
    if i.down then t:+" ^ "+i.down.name
    if i.prv then t:+" < "+i.prv.name
    if i.nxt then t:+" > "+i.nxt.name
    return t
  endfunction
  function tostr2$(i:_tfiles)
    local t$=i.name
    if i.down then t:+" ^ "+i.down.name
    if i.prv then t:+" < "+i.prv.name
    if i.nxt then t:+" > "+i.nxt.name
    return t
  endfunction
  method prnt()
    local i1:_tfiles=drive1
    while i1
      print ":"+tostr2(i1)
      local i2:_tfiles=i1.down
      while i2
        print "  :"+tostr2(i2)
        local i3:_tfiles=i2.down
        while i3
          print "    :"+tostr(i3)
          i3=i3.nxt
        wend
        i2=i2.nxt
      wend
      i1=i1.nxt
    wend
    print "pos:"+pos+", len:"+d.length
    print "dirs:"+dirs+", files:"+files
    print
  endmethod
  method prnt2()
    for local a%=0 until pos
      print tostr(d[a])
    next
    print "pos:"+pos+", len:"+d.length
    print "dirs:"+dirs+", files:"+files
    print
  endmethod
endrem
endtype

'-------------------------------------

type talloc
  field pos%
  field pre%=1024 'power of 2
   field npre%=~(pre-1)

  method setpre(pr%)
    pre=pr
    npre=~(pre-1)
  endmethod

'return new length
'dont forget to add ad to pos after business
' local newlength%=leng(pos+1)
' if (array.length<>newlength) then array=array[..newlength]
' array[pos]=new
' pos:+1
  method leng%(newpos%)
    return (newpos&npre)+pre
  endmethod
endtype

'-------------------------------------
